<?php

/**
 * FiloBlu Rewrite Product ToolBar Block
 *
 * @category    FiloBlu
 * @package     FiloBlu_AjaxLayeredNavigation
 * @author      Vincenzo Assenza
 *
 */

namespace FiloBlu\AjaxLayeredNavigation\Block\Product\ProductList;

use Magento\Catalog\Helper\Product\ProductList;
use Magento\Catalog\Model\Product\ProductList\Toolbar as ToolbarModel;

class Toolbar extends \Magento\Catalog\Block\Product\ProductList\Toolbar {
 
    /**
     * Default direction
     *
     * @var string
     */
    protected $_direction = ProductList::DEFAULT_SORT_DIRECTION;

    /**
     * @var ProductList
     */
    protected $_productListHelper;
    
    /**
     * Retrieve widget options in json format
     *
     * @param array $customOptions Optional parameter for passing custom selectors from template
     * @return string
     */
    public function afterGetWidgetOptionsJson($customOptions = array()) {
        $customOptions = array();
        $defaultMode = $this->_productListHelper->getDefaultViewMode($this->getModes());
        $options = [
            'mode' => ToolbarModel::MODE_PARAM_NAME,
            'direction' => ToolbarModel::DIRECTION_PARAM_NAME,
            'order' => ToolbarModel::ORDER_PARAM_NAME,
            'limit' => ToolbarModel::LIMIT_PARAM_NAME,
            'modeDefault' => $defaultMode,
            'directionDefault' => $this->_direction ? : ProductList::DEFAULT_SORT_DIRECTION,
            'orderDefault' => $this->_productListHelper->getDefaultSortField(),
            'limitDefault' => $this->_productListHelper->getDefaultLimitPerPageValue($defaultMode),
            'url' => $this->getPagerUrl(),
        ];
        $options = array_replace_recursive($options, $customOptions);
        return json_encode(['filobluProductListToolbarForm' => $options]);
    }

}
